import { world } from "@minecraft/server";

world.afterEvents.projectileHitEntity.subscribe((event) => {
    let source = event.source;
    let projectile = event.projectile;
    let sourceLoc = source.location;

    if (projectile.typeId === "minecraft:arrow" && source.typeId === "minecraft:player") {
        let entityHit = event.getEntityHit().entity;
        let hurtTypeId = entityHit.typeId;
        let hurtHealthComponent = entityHit.getComponent("health");

        let isPlayer = hurtTypeId === "minecraft:player";
        let hurtName = isPlayer ? entityHit.name : hurtTypeId.replace("minecraft:", "");
        let hurtHealth = Math.ceil(hurtHealthComponent.currentValue) / 2;

        let statusMessage = hurtHealth > 0
            ? `§2§l${hurtName}§r has §c§l${hurtHealth} hearts§r left!`
            : `§2§l${hurtName}§r is §c§lDead!`;

        // Play sound and send message
        source.playSound("random.orb", sourceLoc);
        source.runCommand(`/tellraw @s {"rawtext":[{"text":"${statusMessage}"}]}`);
    }
});
